<?php
namespace Estoque\Repositories;

class Movilote extends \Doctrine\ORM\EntityRepository
{
    public function insereMovimentacoesAPartirData($filial, $almoxarifado, $local, $produto_ini, $produto_fin, $data, $nrmovilote, $tcdalmoxarife = null, $tcdlocalestoq = null){
        if(!$almoxarifado)
            $tcdalmoxarife = 'T';
        if(!$local)
            $tcdlocalestoq = 'T';

        $sql = <<<SQL
                        INSERT INTO MOVILOTE
                        (NRMOVILOTE, CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO, NRLANCTOORIG)
                        (SELECT :P_NRMOVILOTE AS NRMOVILOTE, IL.CDFILIMOVI, IL.CDALMOXARIFE, IL.CDLOCALESTOQ,
                                IL.NRLOTEESTQ, IL.NRSUBLOTE, IL.CDPRODMOVI, :P_NRMOVILOTE
                        FROM ITLANCTOEST IL, PRODFILI PF, PRODUTO PR
                        WHERE (IL.CDFILIMOVI   = :P_CDFILIAL                              ) AND
                              (IL.CDALMOXARIFE = NVL(:P_CDALMOXARIFE,IL.CDALMOXARIFE) OR :P_TCDALMOXARIFE = 'T') AND
                              (IL.CDLOCALESTOQ = NVL(:P_CDLOCALESTOQ,IL.CDLOCALESTOQ) OR :P_TCDLOCALESTOQ = 'T') AND
                              (PF.CDFILIAL     = :P_CDFILIAL                              ) AND
                              (IL.CDPRODMOVI   = PF.CDPRODUTO                             ) AND
                              (PF.CDPRODUTO    = PR.CDPRODUTO                             ) AND
                              (PR.CDARVPROD BETWEEN :P_PRODINI AND :P_PRODFIM             ) AND
                              (NVL(IL.IDEVOLESTOQ,'S') = 'S'                              ) AND
                              (IL.DTLANCMOVI >= :P_DATAINI                                ) AND
                              (NVL(PF.IDCNTRESTOQ, 'S') = 'S'                             )
                        GROUP BY IL.CDFILIMOVI, IL.CDALMOXARIFE, IL.CDLOCALESTOQ,
                                 IL.NRLOTEESTQ, IL.NRSUBLOTE, IL.CDPRODMOVI,
                                 PR.CDARVPROD, PR.NMPRODUTO)
SQL;

        $params = array(
            "P_CDFILIAL" => $filial,
            "P_CDALMOXARIFE" => $almoxarifado,
            "P_TCDALMOXARIFE" => $tcdalmoxarife,
            "P_CDLOCALESTOQ" => $local,
            "P_TCDLOCALESTOQ" => $tcdlocalestoq,
            "P_PRODINI" => $produto_ini,
            "P_PRODFIM" => $produto_fin,
            "P_DATAINI" => $data,
            "P_NRMOVILOTE" => $nrmovilote,
        );

        try{
            return self::getEntityManager()->getConnection()->executeQuery($sql, $params);
        } catch(\Exception $e) {
            throw $e;
        }
    }

    public function insereMovimentacoesPorProdutoEFilial($filial,$produto_ini, $produto_fin, $lancamento){

        $sql = <<<SQL
            INSERT INTO MOVILOTE
              (NRMOVILOTE, CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO, NRLANCTOORIG)
              (SELECT DISTINCT :P_NRMOVILOTE AS NRMOVILOTE, IL.CDFILIMOVI, IL.CDALMOXARIFE, IL.CDLOCALESTOQ,
              IL.NRLOTEESTQ, IL.NRSUBLOTE, IL.CDPRODMOVI, :P_NRMOVILOTE
            FROM ITLANCTOEST IL, PRODFILI PF, PRODUTO PR
            WHERE (IL.CDFILIMOVI   = :P_CDFILIAL                          ) AND
              (PF.CDFILIAL     = :P_CDFILIAL                              ) AND
              (IL.CDPRODMOVI   = PF.CDPRODUTO                             ) AND
              (PF.CDPRODUTO    = PR.CDPRODUTO                             ) AND
              (PR.CDARVPROD BETWEEN :P_PRODINI AND :P_PRODFIM             ) AND
              (NVL(IL.IDEVOLESTOQ,'S') = 'S'                              ) AND
              (NVL(PF.IDCNTRESTOQ, 'S') = 'S'                             )
            GROUP BY IL.CDFILIMOVI, IL.CDALMOXARIFE, IL.CDLOCALESTOQ,
              IL.NRLOTEESTQ, IL.NRSUBLOTE, IL.CDPRODMOVI,
              PR.CDARVPROD, PR.NMPRODUTO)
SQL;

        $params = array(
            "P_CDFILIAL" => $filial,
            "P_PRODINI" => $produto_ini,
            "P_PRODFIM" => $produto_fin,
            "P_NRMOVILOTE" => $lancamento,
        );

        try{
            return self::getEntityManager()->getConnection()->executeQuery($sql, $params);
        } catch(\Exception $e) {
            throw $e;
        }
    }
}