<?php
/**
 * FpaFormRelatorLogic.
 *
 * @package Logic
 *
 * @author  nataliacesario - ??/06/2011
 *
 */
class FpaFormRelatorLogic{

    private $_paramOperador;
    private $_mesCompetencia;
    private $_nrOrgTrabalho;
    private $_codigoOperador;
    private $_nrOrgOperador;

    private $_formulario;

    private $_dtInicio;
    private $_dtFim;
    private $_dsInicio;
    private $_dsFim;
    private $_nrEstrutura;

     //
    /**
     * Construtor.
     *
     * @param integer    $nrOrgTrabalho  Numero da organizacao de trabalho.
     * @param TkDateTime $mesCompetencia Mes de competencia.
     * @param integer    $nrFormulario   Numero do formulario.
     *
     * @author nataliacesario - ??/06/2011
     */
    public function __construct($nrOrgTrabalho, TkDateTime $mesCompetencia, $nrFormulario, $nrEstrutura){
        /*
         * $this->_codigoOperador = Ambiente::getCdOperador();
         * $this->_nrOrgOperador = Ambiente::getNrorg();
         */
        $this->_nrOrgTrabalho = $nrOrgTrabalho;
        $this->_mesCompetencia = $mesCompetencia;
        $this->_nrEstrutura = $nrEstrutura;

        $this->_inicializaVariaveis($nrFormulario);
    }


    /**
     * Busca dados do formulario.
     *
     * @param integer $nrFormulario Numero do formulario.
     *
     * @return void
     *
     * @author thalesvalias - 28/09/2012
     */
    private function _inicializaVariaveis($nrFormulario){
        $formulario = new FpaFormrelatorEntity();
        $this->_formulario = $formulario->retornaDadosFormularioRelator($this->_nrOrgTrabalho, $nrFormulario);
        if (is_object($this->_formulario) === true) {
            $this->_dtInicio = substr($this->_formulario->getDtinicio(), 0, 10);
            $this->_dtFim = substr($this->_formulario->getDtfim(), 0, 10);
            $this->_dsInicio = $this->_formulario->getDsinicio();
            $this->_dsFim = $this->_formulario->getDsfim();
           // $this->_nrEstrutura = $this->_formulario->getNrestruturam();
            //$this->_dsOrdem = $this->_formulario->getDsordem();
        }
    }


    /**
     * Prepara o relatorio, retornando o valor a ser setado no campo raw text.
     *
     * @param integer $report Nome do relatorio a ser gerado.
     *
     * @return void
     *
     * @author thalesvalias - 01/10/2012
     */
    public function preparaRelatorio($report) {

        // Atribui os parametros do relatorio. Os nomes devem ser identicos aos parametros declarados no Birt.
        $params = array(
            'P_NRORG'             => $this->_nrOrgTrabalho,
            'P_DTAPURACAOINICIAL' => $this->_dtInicio,
            'P_DTAPURACAOFINAL'   => $this->_dtFim,
            'P_NMPESSOAINICIAL'   => $this->_dsInicio,
            'P_NMPESSOAFINAL'     => $this->_dsFim,
            'P_NRESTRUTURA'       => $this->_nrEstrutura
        );

        $format = \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF;
        $birt = \Setforms2\Runtime\Helper\Report\TkBirtReport::getInstance();
        $birt->setReport($report, 'E');
        $birt->setParameterValuesFromArray($params, $format);
        $url = $birt->getUrl();

        $valorRelatorio = "<iframe src='$url' width='100%' height='99%'>";

        return $valorRelatorio;
    }


    /*
      public function retornaTpMovMensal(){
          return FpatipomovimentEntity::TP_MOV_MENSAL;
      }

      public function retornaNrOrgTrabalho(){
          $paramOperador = new GpeparamoperEntity();
          $nrOrgTrabalho = $paramOperador->retornaNrOrgTrabalho($this->_nrOrgOperador, $this->_codigoOperador);
          return $nrOrgTrabalho;
      }
     */


    /**
     * Recupera o numero de calculo folha.
     *
     * @param integer $tipoMovimento Tipo de movimento.
     *
     * @return integer
     *
     * @author nataliacesario - ??/06/2011
     */
    public function encontraNumeroCalculo($tipoMovimento){

        /*
         * $paramOperador = new GpeparamoperEntity();
         * $mesCompetencia = $paramOperador->retornaMesCompetenciaOperador(
         * 	$this->_nrOrgOperador, $this->_codigoOperador
         * );
         * $mesCompetencia = new TkDateTime($mesCompetencia);
         * $nrOrgTrabalho = $paramOperador->retornaNrOrgTrabalho($this->_nrOrgOperador, $this->_codigoOperador);
         */

        $calculoFolha  = new FpacalculofolhaEntity();

        $objCalculoFolha = current(
            $calculoFolha->retornaCalculoFolha($this->_nrOrgTrabalho, $tipoMovimento, $this->_mesCompetencia)
        );
        if (is_object($objCalculoFolha) === true) {
            return $objCalculoFolha->getNrcalculofolha();
        } else {
            return null;
        }
    }


}