<?php

/**
 * GepProdutofluxoLogic.
 *
 * @package Logic
 * @author  erikasouza
 */
class GepProdutofluxoLogic{


    private $_GepProdutofluxoEntity;


    /**
     * Construtor da classe.
     */
    public function __construct(){
        $this->_GepProdutofluxoEntity = new GepProdutofluxoEntity();
    }


    /**
     * Gera novo c?o de Produto por Tipo de Fluxo.
     *
     * @param integer $nrorg N?o da Organiza?.
     *
     * @return $codigo integer
     */
    public static function retornaProxNumeroProdutoFluxo($nrorg){
        $codigo = GepProdutofluxoEntity::retornaProxNumeroProdutoFluxo($nrorg);
        return $codigo;
    }


    /**
     * Retorna os produtos de um tipo de fluxo.
     *
     * @param integer $nrorg   N?o da Organiza?.
     * @param integer $tpfluxo Tipo de fluxo.
     *
     * @return Ambigous <boolean, mixed, NULL>
     */
    public function retornaProdutosFluxo($nrorg, $tpfluxo){
        try{
            $dados = $this->_GepProdutofluxoEntity->dadosProdutosFluxo($nrorg, $tpfluxo);
            return $dados;
        } catch (Exception $e) {
            switch ($e->getCode()) {
                case GepProdutofluxoEntity::SEM_PRODUTO:
                    return false;
                default:
                    tk_message('Erro desconhecido'.$e->getMessage());
            }

        }

    }


    /*public function salvaProdutoFluxo($nrorg, $cdarvprod, $oper, $tpfluxo) {
        $aux = 0;
        $data = now();

        $lista_filhos = ProdutoEntity::retornaFilhosProduto($nrorg, $cdarvprod);
        if ($lista_filhos !== ProdutoEntity::RESULTADO_SEM_REGISTRO) {
            foreach ($lista_filhos as $filhos) {
                $resultado = $this->retornaProdutoFluxo($nrorg, $tpfluxo, $filhos['CDPRODUTO']);
                if ($resultado !== false OR is_object($resultado) !== false) {
                    $aux++;
                } else {
                    $param['NRPRODUTOFLUXO'] = self::retornaProxNumeroProdutoFluxo($nrorg);
                    $param['NRTIPOFLUXO'] = $tpfluxo;
                    $param['CDPRODUTO'] = $filhos['CDPRODUTO'];
                    $param['IDATIVO'] = 'S';
                    $param['NRORG'] = $nrorg;
                    $param['DTINCLUSAO'] = $data;
                    $param['DTULTATU'] = $data;
                    $param['NRORGINCLUSAO'] = $nrorg;
                    $param['CDOPERINCLUSAO'] = $oper;
                    $param['NRORGULTATU'] = $nrorg;
                    $param['CDOPERULTATU'] = $oper;

                    $insert = $this->_GepProdutofluxoEntity->salvaProdutoFluxo($param);
                }
            }
        }

        return $aux;
    }*/


    public function salvaProdutoFluxo($nrorg, $lista_produtos, $oper, $tpfluxo) {
        $aux = 0;
        $data = now();

        foreach ($lista_produtos as $produtos) {
            $resultado = $this->retornaProdutoFluxo($nrorg, $tpfluxo, $produtos['CDPRODUTO']);
            if (is_object($resultado) === false) {
                $param['NRPRODUTOFLUXO'] = self::retornaProxNumeroProdutoFluxo($nrorg);
                $param['NRTIPOFLUXO'] = $tpfluxo;
                $param['CDPRODUTO'] = $produtos['CDPRODUTO'];
                $param['IDATIVO'] = 'S';
                $param['NRORG'] = $nrorg;
                $param['DTINCLUSAO'] = $data;
                $param['DTULTATU'] = $data;
                $param['NRORGINCLUSAO'] = $nrorg;
                $param['CDOPERINCLUSAO'] = $oper;
                $param['NRORGULTATU'] = $nrorg;
                $param['CDOPERULTATU'] = $oper;

                $insert = $this->_GepProdutofluxoEntity->salvaProdutoFluxo($param);
            }
        }

        return true;
    }


    public function retornaProdutoFluxo($nrorg, $tpfluxo, $cdproduto){
        try{
            $dados = $this->_GepProdutofluxoEntity->dadosProdutoFluxo($nrorg, $tpfluxo, $cdproduto);
            return $dados;
        } catch (Exception $e) {
            switch ($e->getCode()) {
                case GepProdutofluxoEntity::SEM_PRODUTO:
                    return false;
                default:
                    tk_message('Erro desconhecido'.$e->getMessage());
            }

        }

    }


}